execute as @a[tag=startingTutorial] run tag @s add playingTutorial
execute as @a[tag=startingTutorial] run tag @s add playingSerration
execute as @a[tag=startingTutorial] run effect give @s minecraft:instant_health 10 10 true
execute as @a[tag=startingTutorial] run scoreboard players set @s serrModCapacity 10
execute as @a[tag=startingTutorial] run scoreboard players set @s serrIntDeath 0
execute as @a[tag=startingTutorial] run scoreboard players set @s serrTutorialProg 0
execute as @a[tag=startingTutorial] run scoreboard players set @s serrAutoCont 1
execute as @a[tag=startingTutorial] run tag @s remove startingTutorial

# If someone relogs, prompt them again
scoreboard players set @a[tag=playingTutorial,scores={hasJoined=1..}] serrTutorialCont 1
scoreboard players set @a[scores={hasJoined=1..}] hasJoined 0

# keep track of number of each resource
execute as @a[tag=playingTutorial] store result score @s serrTutAur run clear @s minecraft:gold_ingot 0
execute as @a[tag=playingTutorial] store result score @s serrTutFer run clear @s minecraft:iron_ingot 0
execute as @a[tag=playingTutorial] store result score @s serrTutCer run clear @s minecraft:brick 0
execute as @a[tag=playingTutorial] store result score @s serrTutFor run clear @s minecraft:nether_brick 0

tag @a[tag=playingTutorial] add playingSerration
scoreboard players enable @a[tag=playingTutorial] serrTutorialCont

effect clear @a[tag=playingTutorial] minecraft:wither
execute as @a[tag=playingTutorial] run effect give @s minecraft:resistance 2 4 true

execute as @a[scores={serrAutoCont=1..}] run scoreboard players operation @s serrTutorialCont = @s serrAutoCont
scoreboard players set @a[scores={serrAutoCont=1..}] serrAutoCont 0
scoreboard players set @a[tag=!playingTutorial,scores={serrTutorialCont=1..}] serrTutorialCont 0
scoreboard players set @a[tag=!playingTutorial,scores={serrTutorialProg=1..}] serrTutorialProg 0

execute as @a[scores={serrTutorialCont=1..}] if score @s serrTutorialCont > @s serrTutorialProg run scoreboard players operation @s serrTutorialProg = @s serrTutorialCont

# tellraw @a[scores={serrTutorialProg=6,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"text":"\n[Click to continue]","color":"gold","clickEvent":{"action":"run_command","value":"/trigger serrTutorialCont set 1"}}]

gamemode adventure @a[scores={serrTutorialProg=1,serrTutorialCont=1..}]
scoreboard players set @a[scores={serrTutorialProg=1,serrTutorialCont=1..}] serrLoadout 1

tellraw @a[scores={serrTutorialProg=1,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.1","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.continue","color":"gold","clickEvent":{"action":"run_command","value":"/trigger serrTutorialCont set 2"}}]

tp @a[scores={serrTutorialProg=2,serrTutorialCont=1..}] -1122 199 -865 45 9
tellraw @a[scores={serrTutorialProg=2,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.2","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.continue","color":"gold","clickEvent":{"action":"run_command","value":"/trigger serrTutorialCont set 3"}}]

tp @a[scores={serrTutorialProg=3,serrTutorialCont=1..}] -1120 199 -828 90 0
execute at @a[scores={serrTutorialProg=3,serrTutorialCont=1..}] as @e[type=armor_stand,name=RandomQuarryOre,distance=..30] run scoreboard players set @s quarryTimer 99999
tellraw @a[scores={serrTutorialProg=3,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.3","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal0","color":"gold"}]
scoreboard players set @a[scores={serrTutorialProg=3,serrTutAur=3..,serrTutFor=2..,serrTutFer=1..,serrTutCer=1..},nbt={Inventory:[{tag:{SerrVaultKey:1b}}]}] serrAutoCont 4

tp @a[scores={serrTutorialProg=4,serrTutorialCont=1..}] -1120 199 -796 90 0
loot give @a[scores={serrTutorialProg=4,serrTutorialCont=1..,serrTutAur=..2}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=4,serrTutorialCont=1..,serrTutAur=..2}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=4,serrTutorialCont=1..,serrTutAur=..2}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=4,serrTutorialCont=1..,serrTutFor=..1}] loot serration:fortanium
loot give @a[scores={serrTutorialProg=4,serrTutorialCont=1..,serrTutFor=..1}] loot serration:fortanium
tellraw @a[scores={serrTutorialProg=4,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.4","color":"green","with":[[{"text":"\ue000 ","color":"white","italic":false,"hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.aurelium2","color":"yellow"}]}},{"text":"3 ","color":"yellow"},{"translate":"serration.item.aurelium2","color":"yellow"}],[{"text":"\ue003 ","color":"white","italic":false,"hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.fortanium2","color":"red"}]}},{"text":"2 ","color":"red"},{"translate":"serration.item.fortanium2","color":"red"}]]},{"text":"\n"},{"translate":"serration.tutorial.goal1","color":"gold"}]
execute as @a[scores={serrTutorialProg=4},nbt={SelectedItem:{tag:{IsSword:1b}}}] run scoreboard players set @s[nbt=!{SelectedItem:{tag:{SwordID:0s}}}] serrAutoCont 5

tp @a[scores={serrTutorialProg=5,serrTutorialCont=1..}] -1120 199 -764 90 0
loot give @a[scores={serrTutorialProg=5,serrTutorialCont=1..},nbt=!{Inventory:[{tag:{SerrVaultKey:1b}}]}] loot serration:key
tellraw @a[scores={serrTutorialProg=5,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.5","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal2","color":"gold"}]
scoreboard players set @a[scores={serrTutorialProg=5},nbt={Inventory:[{tag:{IsMod:1b}}]}] serrAutoCont 6

tellraw @a[scores={serrTutorialProg=6,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.6","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal3","color":"gold"}]
execute as @a[scores={serrTutorialProg=6},nbt={Inventory:[{tag:{SerrPearl:1b}}]}] at @s unless entity @e[type=item,nbt={Item:{tag:{SerrVaultKey:1b}}},distance=..5] run scoreboard players set @s serrAutoCont 7

execute as @a[scores={serrTutorialProg=7,serrTutorialCont=1..}] run kill @e[type=armor_stand,tag=serrEliteBolt]
tp @a[scores={serrTutorialProg=7,serrTutorialCont=1..}] -1120 199 -796 90 0
loot give @a[scores={serrTutorialProg=7,serrTutorialCont=1..},nbt=!{Inventory:[{tag:{IsMod:1b}}]}] loot serration:vault
tellraw @a[scores={serrTutorialProg=7,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.7","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal4","color":"gold"}]
execute as @a[scores={serrTutorialProg=7}] store result score @s serrTutMCU run data get entity @s SelectedItem.tag.ModCapacityUsed
scoreboard players set @a[scores={serrTutorialProg=7,serrTutMCU=1..}] serrAutoCont 8

loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
loot give @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] loot serration:ceranite
tellraw @a[scores={serrTutorialProg=8,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.8","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal5","color":"gold"}]
scoreboard players set @a[scores={serrTutorialProg=8},nbt={Inventory:[{tag:{IsSword:1b,Notches:1b}}]}] serrAutoCont 9

loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
loot give @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] loot serration:aurelium
tellraw @a[scores={serrTutorialProg=9,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.9","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal6","color":"gold"}]
scoreboard players set @a[scores={serrTutorialProg=9},nbt={Inventory:[{tag:{IsSword:1b,Notches:2b}}]}] serrAutoCont 10

loot give @a[scores={serrTutorialProg=10,serrTutorialCont=1..},nbt=!{Inventory:[{tag:{SerrPearl:1b}}]}] loot serration:pearl
tellraw @a[scores={serrTutorialProg=10,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.10","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal7","color":"gold"}]
scoreboard players set @a[scores={serrTutorialProg=10},nbt={Inventory:[{tag:{IsSword:1b,HasPearl:1b}}]}] serrAutoCont 11

tp @a[scores={serrTutorialProg=11,serrTutorialCont=1..}] -1120 199 -733 90 0
tellraw @a[scores={serrTutorialProg=11,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.11","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal8","color":"gold"}]
execute as @a[scores={serrTutorialProg=11},nbt={Inventory:[{tag:{IsSword:1b,TimesDrilled:1}}]}] at @s unless entity @e[type=item,distance=..10] run scoreboard players set @s serrAutoCont 12

tellraw @a[scores={serrTutorialProg=12,serrTutorialCont=1..}] [{"text":"\n","color":"green"},{"translate":"serration.tutorial.12","color":"green"},{"text":"\n"},{"translate":"serration.tutorial.goal9","color":"gold","clickEvent":{"action":"run_command","value":"/trigger serrTutorialCont set 13"}}]

execute as @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] at @s run tp @e[tag=serrElite,distance=..100] ~ -1000 ~
execute as @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] at @s run kill @e[type=item,distance=..100,tag=!serrUnkillable]
effect give @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] minecraft:instant_health 10 10 true
tp @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] -1142 96 -952 0 0
spawnpoint @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] -1142 96 -952
advancement grant @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] only serration:tutorial
clear @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}]
tag @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] remove playingTutorial
tag @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] remove playingSerration
scoreboard players set @a[scores={serrTutorialProg=13..,serrTutorialCont=1..}] serrTutorialProg 0

execute as @a[scores={serrTutorialCont=1..}] at @s run playsound minecraft:ui.button.click block @s ~ ~ ~ 2 1
scoreboard players set @a[scores={serrTutorialCont=1..}] serrTutorialCont 0

# other misc mechanics

# make sure there is always a bell if there's no elite
execute as @e[type=armor_stand,tag=serrTutBell] at @s unless entity @e[tag=serrElite,distance=..100] unless entity @e[type=item,nbt={Item:{tag:{SerrPearl:1b}}},distance=..50] run setblock ~ ~ ~ minecraft:bell[attachment=ceiling,facing=north]

# if the elite jumps on the shrine, teleport him off
execute as @e[tag=serrElite] at @s unless entity @s[x=-1135,y=210,z=-772,dx=16,dy=-7,dz=16] run scoreboard players set @s serrEliteIllegalTimer 0
execute as @e[tag=serrElite] at @s if entity @s[x=-1135,y=210,z=-772,dx=18,dy=-7,dz=18] run scoreboard players add @s serrEliteIllegalTimer 1
execute as @e[tag=serrElite,scores={serrEliteIllegalTimer=60..}] at @s run tp @s @a[tag=playingTutorial,distance=..25,sort=nearest,limit=1]

# clone A: /clone -1148 193 -905 -1143 202 -900 ~ ~ ~ replace
# clone B: /clone -1148 193 -898 -1143 202 -893 ~ ~ ~ replace
# clone C: /clone -1148 193 -891 -1143 202 -886 ~ ~ ~ replace

# rotate the pads for the first room
execute unless entity @a[scores={serrTutorialProg=1}] if score World serrTurntableN >= -1 Constants run scoreboard players set World serrTurntableN 0
execute if entity @a[scores={serrTutorialProg=1}] run scoreboard players add World serrTurntableN 1
execute if score World serrTurntableN = 0 Constants run clone -1148 193 -905 -1143 202 -900 -1134 196 -898 replace
execute if score World serrTurntableN = 0 Constants run clone -1148 193 -898 -1143 202 -893 -1135 197 -890 replace
execute if score World serrTurntableN = 0 Constants run clone -1148 193 -891 -1143 202 -886 -1125 194 -891 replace
execute if score World serrTurntableN = 50 Constants run clone -1148 193 -905 -1143 202 -900 -1125 194 -891 replace
execute if score World serrTurntableN = 50 Constants run clone -1148 193 -898 -1143 202 -893 -1134 196 -898 replace
execute if score World serrTurntableN = 50 Constants run clone -1148 193 -891 -1143 202 -886 -1135 197 -890 replace
execute if score World serrTurntableN = 100 Constants run clone -1148 193 -905 -1143 202 -900 -1135 197 -890 replace
execute if score World serrTurntableN = 100 Constants run clone -1148 193 -898 -1143 202 -893 -1125 194 -891 replace
execute if score World serrTurntableN = 100 Constants run clone -1148 193 -891 -1143 202 -886 -1134 196 -898 replace
execute if score World serrTurntableN >= 150 Constants run scoreboard players set World serrTurntableN -1
execute unless entity @a[scores={serrTutorialProg=1}] run scoreboard players set World serrTurntableN -2